// MAcolor.mq4

#property  copyright "Ale"

#property  indicator_chart_window
#property  indicator_buffers 3
#property indicator_color1 DeepPink
#property indicator_color2 DodgerBlue
#property indicator_color3 Silver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2


double
	glo_dBuffDown[], glo_dBuffUp[], glo_dBuffFlat[],
	glo_dFlatPips
;

extern int		MAType = 1;
extern int		MAPeriod = 21;
extern int		MAShift = 0;
extern int		PriceType = 0;
extern double	FlatPips = 2;


int init() {
	SetIndexBuffer(0, glo_dBuffDown);
	SetIndexBuffer(1, glo_dBuffUp);
	SetIndexBuffer(2, glo_dBuffFlat);
	SetIndexStyle(0, DRAW_ARROW);
	SetIndexStyle(1, DRAW_ARROW);
	SetIndexStyle(2, DRAW_ARROW);
	SetIndexArrow(0, 159);
	SetIndexArrow(1, 159);
	SetIndexArrow(2, 159);
	
	glo_dFlatPips = FlatPips * Point;
	
	return(0);
}


int start() {
	double
		dMAcurr, dMAprev
	;
	int
		iBarsLimit = 20000,
		iBar,
		iBarsToCount, iBarsCounted = IndicatorCounted()
	;
	
	if(iBarsCounted < 0) return(-1);
	if(iBarsCounted > 0) iBarsCounted--;
	iBarsToCount = MathMin(Bars - iBarsCounted, iBarsLimit);
	
	for(iBar = iBarsToCount; iBar > -1; iBar--) {
		dMAcurr = iMA(NULL, 0, MAPeriod, MAShift, MAType, PriceType, iBar);
		dMAprev = iMA(NULL, 0, MAPeriod, MAShift, MAType, PriceType, iBar + 1);
		if(dMAcurr > dMAprev + glo_dFlatPips) {
			glo_dBuffUp[iBar] = dMAcurr;
			glo_dBuffDown[iBar] = EMPTY_VALUE;
			glo_dBuffFlat[iBar] = EMPTY_VALUE;
		}
		else if(dMAcurr < dMAprev - glo_dFlatPips) {
			glo_dBuffDown[iBar] = dMAcurr;
			glo_dBuffUp[iBar] = EMPTY_VALUE;
			glo_dBuffFlat[iBar] = EMPTY_VALUE;
		}
		else {
			glo_dBuffFlat[iBar] = dMAcurr;
			glo_dBuffUp[iBar] = EMPTY_VALUE;
			glo_dBuffDown[iBar] = EMPTY_VALUE;
		}
	}
	
	return(0);
}